#ifndef __AP_ABILITY_H__
#define __AP_ABILITY_H__

#include <glib.h>
#include <glib-object.h>

G_BEGIN_DECLS

#define AP_TYPE_ABILITY (ap_ability_get_type ())

G_DECLARE_FINAL_TYPE (APAbility, ap_ability, AP, ABILITY, GObject)

APAbility *
ap_ability_new (void);

APAbility *
ap_ability_new_with_name (gchar *name);

void
ap_ability_set_name (APAbility *self,
                     gchar     *name);

gchar *
ap_ability_get_name (APAbility *self);

gint
ap_ability_get_score (APAbility *self);

gint
ap_ability_get_modifier (APAbility *self);

void
ap_ability_set_base (APAbility *self,
                     gint       base);

gint
ap_ability_get_base (APAbility *self);

void
ap_ability_set_racial_bonus (APAbility *self,
                             gint       score);

gint
ap_ability_get_racial_bonus (APAbility *self);

void
ap_ability_set_ability_improvements (APAbility *self,
                                     gint       ability_improvements);

gint
ap_ability_get_ability_improvements (APAbility *self);

void
ap_ability_set_miscellaneous_bonus (APAbility *self,
                                    gint       miscellaneous_bonus);

gint
ap_ability_get_miscellaneous_bonus (APAbility *self);

void
ap_ability_set_other_modifier (APAbility *self,
                               gint       other_modifier);

gint
ap_ability_get_other_modifier (APAbility *self);

void
ap_ability_set_override_score (APAbility *self,
                               gint       override_score);

gint
ap_ability_get_override_score (APAbility *self);

G_END_DECLS

#endif /* __AP_ABILITY_H__ */

