#ifndef __AP_CHARACTER_H__
#define __AP_CHARACTER_H__

#include "ap-ability.h"
#include "ap-skill.h"
#include "ap-weapon.h"

#include <glib.h>
#include <glib-object.h>

G_BEGIN_DECLS

#define AP_TYPE_CHARACTER (ap_character_get_type ())

G_DECLARE_FINAL_TYPE (APCharacter, ap_character, AP, CHARACTER, GObject)

APCharacter *
ap_character_new (void);

APCharacter *
ap_character_get_default (void);

gboolean
ap_character_add_ability (APCharacter *self,
                        APAbility *ability);

APAbility *
ap_character_get_ability (APCharacter *self,
                        gchar     *name);

gboolean
ap_character_remove_ability (APCharacter *self,
                           gchar     *name);

gboolean
ap_character_add_skill (APCharacter *self,
                      APSkill   *skill);

APSkill *
ap_character_get_skill (APCharacter *self,
                      gchar     *id);

gboolean
ap_character_remove_skill (APCharacter *self,
                         gchar     *id);

GList *
ap_character_get_abilities (APCharacter *self);

void
ap_character_remove_abilities (APCharacter *self);

GList *
ap_character_get_skills (APCharacter *self);

void
ap_character_remove_skills (APCharacter *self);

void
ap_character_remove_all (APCharacter *self);

G_END_DECLS

#endif /* __AP_CHARACTER_H__ */

