#ifndef __TEST_CHARACTER_H__
#define __TEST_CHARACTER_H__

#include <adventure-pack/ap-character.h>

#include <glib.h>

G_BEGIN_DECLS

typedef struct {
    APCharacter *character;
} CharacterFixture;

void
character_fixture_set_up (CharacterFixture *fixture,
                          gconstpointer     user_data);

void
character_fixture_tear_down (CharacterFixture *fixture,
                             gconstpointer     user_data);

void
test_character_ability_add (CharacterFixture *fixture,
                            gconstpointer     user_data);

void
test_character_ability_add_with_no_name (CharacterFixture *fixture,
                                         gconstpointer     user_data);

void
test_character_ability_add_with_duplicate_name (CharacterFixture *fixture,
                                                gconstpointer     user_data);

void
test_character_ability_get (CharacterFixture *fixture,
                            gconstpointer     user_data);

void
test_character_skill_add (CharacterFixture *fixture,
                          gconstpointer     user_data);

void
test_character_skill_add_with_no_name (CharacterFixture *fixture,
                                       gconstpointer     user_data);

void
test_character_skill_add_with_duplicate_name (CharacterFixture *fixture,
                                              gconstpointer     user_data);

void
test_character_skill_get (CharacterFixture *fixture,
                          gconstpointer     user_data);

void
test_character_remove_ability (CharacterFixture *fixture,
                               gconstpointer     user_data);

void
test_character_remove_abilities (CharacterFixture *fixture,
                                 gconstpointer     user_data);

void
test_character_remove_skill (CharacterFixture *fixture,
                             gconstpointer     user_data);

void
test_character_remove_skills (CharacterFixture *fixture,
                              gconstpointer     user_data);

void
test_character_remove_all (CharacterFixture *fixture,
                           gconstpointer     user_data);

void
test_character_signal_ability_base_score_changed_skill_score_changed (CharacterFixture *fixture,
                                                                      gconstpointer     user_data);

void
test_character_signal_skill_modifier_changed (CharacterFixture *fixture,
                                              gconstpointer     user_data);

void
test_character_check_skill_for_lingering_bind_with_ability (CharacterFixture *fixture,
                                                            gconstpointer     user_data);

G_END_DECLS

#endif /* __TEST_CHARACTER_H__ */
